//+------------------------------------------------------------------+
//|                                                      ProjectName |
//|                                      Copyright 2010, CompanyName |
//|                                       http://www.companyname.net |
//+------------------------------------------------------------------+
/*
 * <<<    METATRADER 5 >>> *
 *
 *  DF.dll     "\MetaTrader 5\MQL5\Libraries\".
 * !   DF.dll    DLL,
 *     - bdsp.dll, lapack.dll, mkl_support.dll,
 *      "C:\Windows\System32\"  32-  
 *   Windows *   "C:\Windows\SysWOW64\"  64-  
 *   Windows.
 *
 *   :
 * 
 * 1.      ->->   "  DLL".
 * 2.    "C:\Windows\System32\"   "C:\Windows\SysWOW64\"  
 * Bdsp.dll, lapack.dll, mkl_support.dll -   .
 *
 *   :
 * 
 * Ftype  -  : 0 -  (FATL/SATL/KGLP), 1 -  (KGHP), 
 *          2 -  (RBCI/KGBP), 3 -  (KGBS)
 * P1     -   P1, 
 * D1     -     D1, 
 * A1     -     1, 
 * P2     -   P2, 
 * D2     -     D2, 
 * A2     -     2, 
 * Ripple -    , 
 * Delay  -  , 
 *
 *       P2,D2,A2 
 *
 *  :
 * :                     P1>D1
 * :                     P1<D1
 *   : D2>P2>P1>D1
 */
//+------------------------------------------------------------------+
//|       Digital Low Pass (FATL/SATL, KGLP) Filter    DFilter_0.mq5 | 
//|                    Digital Filter: Copyright (c) Sergey Ilyukhin |
//|                           Moscow, qpo@mail.ru  http://fx.qrz.ru/ |
//|                              MQL5 CODE: 2010,   Nikolay Kositsin |
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+
//----  
#property copyright "2005, Sergey Ilyukhin, Moscow"
//----    
#property link      "http://fx.qrz.ru/"
//----   
#property version   "1.00"
//----     
#property indicator_chart_window
//----        
#property indicator_buffers 1
//----     
#property indicator_plots   1
//----     
#property indicator_type1   DRAW_LINE
//----        
#property indicator_color1  DarkViolet
//----   -  
#property indicator_style1  STYLE_SOLID
//----     2
#property indicator_width1  2
//----   
#property indicator_label1  "DFilter"

//----   
input int FType=0;          // 
                            //0 -  (FATL/SATL/KGLP), 1 -  (KGHP), 2 -  (RBCI/KGBP), 3 -  (KGBS)
input int    P1 = 28;       //  1, 
input int    D1 = 19;       //    1, 
input int    A1 = 40;       //    1, 
input int    P2 = 0;        //  2, 
input int    D2 = 0;        //    2, 
input int    A2 = 0;        //    2, 
input int    Delay=0;       //, 
input double Ripple=0.08;   //   ,  
input int    FILTERShift=0; //      

//----  DLL 
#import "DF.dll"
int DigitalFilter(int FType,int P1,int D1,int A1,int P2,int D2,int A2,double Ripple,int Delay,double &array[]);
#import

//----         
int FILTERPeriod;

//----   ,    
//      
double ExtLineBuffer[];

//----        
double FILTERTable[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+  
void OnInit()
  {
//----+
//----    ExtLineBuffer   
   SetIndexBuffer(0,ExtLineBuffer,INDICATOR_DATA);
//----       FILTERShift
   PlotIndexSetInteger(0,PLOT_SHIFT,FILTERShift);
//----  ,     
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,FILTERPeriod);
//----      
   string shortname;
   StringConcatenate(shortname,"FILTER(",FILTERShift,")");
//----       
   PlotIndexSetString(0,PLOT_LABEL,shortname);
//----           
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);
//----     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits+1);
//----      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,0.0);
//----         FILTERTable[]
   double Array[1500];
   FILTERPeriod=DigitalFilter(FType,P1,D1,A1,P2,D2,A2,Ripple,Delay,Array);
//----     FILTERTable[]      
   if(FILTERPeriod<=0)
     {
      Print("  .   !");
      return;
     }
//----       1500      FILTERPeriod
   ArrayCopy(FILTERTable,Array,0,0,FILTERPeriod);
//----+
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(
                const int rates_total,     //       
                const int prev_calculated, //       
                const int begin,           //     
                const double &price[]      //     
                )
  {
//----+   
//----       
   if(rates_total<FILTERPeriod-1+begin)
      return(0);

//----    
   int first,bar,iii;
   double Sum,FILTER;

//----    first    
   if(prev_calculated==0)         //      
     {
      first=FILTERPeriod-1+begin; //      
      //----      begin ,      
      if(begin>0)
         PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,begin+FILTERPeriod);
     }
   else first=prev_calculated-1;  //      

//----    
   for(bar=first; bar<rates_total; bar++)
     {
      //----     
      FILTER=0.0;
      for(iii = 0; iii<FILTERPeriod; iii++)
         FILTER+= FILTERTable[iii] * price[bar - iii];

      //----       FILTER
      ExtLineBuffer[bar]=FILTER;
     }
//----+     
   return(rates_total);
  }
//+------------------------------------------------------------------+
